Skip site navigation (1)Skip section navigation (2)
Date:      Tue, 10 Nov 2020 08:33:45 +0000 (UTC)
From:      Mateusz Piotrowski <0mp@FreeBSD.org>
To:        src-committers@freebsd.org, svn-src-all@freebsd.org, svn-src-stable@freebsd.org, svn-src-stable-12@freebsd.org
Subject:   svn commit: r367547 - stable/12/tools/build
Message-ID:  <202011100833.0AA8XjNR063451@repo.freebsd.org>

next in thread | raw e-mail | index | archive | help
Author: 0mp (doc,ports committer)
Date: Tue Nov 10 08:33:45 2020
New Revision: 367547
URL: https://svnweb.freebsd.org/changeset/base/367547

Log:
  MFC r367072:
  
  Mount devfs inside a beinstall(8) chroot
  
  It turns out that without /dev/null beinstall is not able to complete and
  instead exits with messages similar to these:
  
    --------------------------------------------------------------
    >>> Installing kernel GENERIC completed on Sun Oct 25 17:47:37 CET 2020
    --------------------------------------------------------------
    /tmp/beinstall.JleGoP/mnt: Inspecting dirs /usr/src /usr/obj/usr/src/amd64.amd64
    --- installworld ---
    make[1]: "/usr/obj/usr/src/amd64.amd64/toolchain-metadata.mk" line 1: Using cached toolchain metadata from build at t480 on Sun Oct 25 15:53:28 CET 2020
    make[2]: "/dev/null" line 2: Need an operator
    make[2]: Fatal errors encountered -- cannot continuemake[1]: "/usr/src/Makefile.inc1" line 593: CPUTYPE global should be set with ?=.
    Cleaning up ...
    umount -f /tmp/beinstall.JleGoP/mnt/usr/src /tmp/beinstall.JleGoP/mnt/usr/obj/usr/src/amd64.amd64 /tmp/beinstall.JleGoP/mnt
    Destroyed successfully
    error: Installworld failed!
  
  Upon a bit of debugging, it turns out that /dev/null inside the chroot
  environment is full random bytes, which cause "make -f /dev/null" to
  misbehave. Mounting a proper devfs inside the chroot seems to be the most
  appropriate way to fix it.
  
  will@ also noted that this change requires that whatever is needed in devfs
  must exist in the old kernel.
  
  Approved by:	will

Modified:
  stable/12/tools/build/beinstall.sh
Directory Properties:
  stable/12/   (props changed)

Modified: stable/12/tools/build/beinstall.sh
==============================================================================
--- stable/12/tools/build/beinstall.sh	Tue Nov 10 07:47:24 2020	(r367546)
+++ stable/12/tools/build/beinstall.sh	Tue Nov 10 08:33:45 2020	(r367547)
@@ -216,6 +216,7 @@ fi
 create_be_dirs "${srcdir}" "${objdir}" || errx "Unable to create BE dirs"
 mount -t nullfs "${srcdir}" "${BE_MNTPT}${srcdir}" || errx "Unable to mount src"
 mount -t nullfs "${objdir}" "${BE_MNTPT}${objdir}" || errx "Unable to mount obj"
+mount -t devfs devfs "${BE_MNTPT}/dev" || errx "Unable to mount devfs"
 
 chroot ${BE_MNTPT} make "$@" -C ${srcdir} installworld || \
 	errx "Installworld failed!"



Want to link to this message? Use this URL: <https://mail-archive.FreeBSD.org/cgi/mid.cgi?202011100833.0AA8XjNR063451>